/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.14C */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "pglos.h"
#include "abimport.h"
#include "proto.h"

static PtWidget_t *HashDlg = NULL;
static offset_t maxValue;
static char *pr_name = NULL;

void RunHashDlg( const char *pr, offset_t _maxValue )
{
	ApCreateModule( ABM_CreateHashDlg, NULL, NULL );

	pr_name = strdup( pr );

	if( HashDlg )
		maxValue = _maxValue;
}

void DestroyHashDlg()
{
	if( HashDlg )
	{
		PtDestroyWidget( HashDlg );
		HashDlg = NULL;
		free( pr_name );
		pr_name = NULL;
	}
}

void UpdateHashDlg( offset_t _curValue )
{
	if( HashDlg )
	{	
		char str[1024];
		offset_t curValue = _curValue/(maxValue/100);
		sprintf( str, "%s %ld%%", pr_name, curValue );
		SetWidgetText( ABW_cur_hash, str );
	}
}

int
InitCreateHashDlg( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{

	/* eliminate 'unreferenced' warnings */
	HashDlg = link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );
}
