
/* ../HashDlg.c */
void RunHashDlg ( const char *pr , offset_t _maxValue );
void DestroyHashDlg ( void );
void UpdateHashDlg ( offset_t _curValue );
int InitCreateHashDlg ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../abmain.c */
int main ( int argc , char *argv []);

/* ../pglos.c */
void LoadGlossary ( char *gl_name );
int GlosSelect ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int InitBase ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int InitializeMain ( int argc , char *argv []);
int gls_item_select ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int input_mask ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int ShutDown ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int add_wrd_sel ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int srch_word_key ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../collection.c */
int InitCollection ( Collection *mq , int _dataSize , int _delta );
int AddItem ( Collection *mq , void *ptr );
int InsertItem ( Collection *mq , int i , void *ptr );
int RemoveItembyAddress ( Collection *mq , void *ptr );
int RemoveItembyIndex ( Collection *mq , int i );
int RemoveAllItems ( Collection *mq );
int DeleteItembyAddress ( Collection *mq , void *ptr );
int DeleteItembyIndex ( Collection *mq , int i );
int DeleteAllItems ( Collection *mq );
void *GetItembyIndex ( Collection *mq , int i );
void *GetLastItem ( Collection *mq );
void *GetFirstItem ( Collection *mq );
int GetIndexbyItem ( Collection *mq , void *ptr );
void ChangeItemsPlace ( Collection *mq , int i , int j );

/* ../hash.c */
offset_t FindInHash ( char *key );
void AddInHash ( char *key , offset_t off );
void DestroyHash ( void );
void DeleteHash ( void );
void CreateHash ( FILE *fp , char *name );
BOOL WriteHash ( const char *gl_name );
BOOL ReadHash ( const char *gl_name );

/* ../widget_lib.c */
int DestroyWindow ( PtWidget_t *w );
void EnableWidget ( PtWidget_t *w );
void DisableWidget ( PtWidget_t *w );
void SetWindowNormal ( PtWidget_t *w );
void SetWindowTitle ( PtWidget_t *w , char *s );
void SetWidgetText ( PtWidget_t *w , char *s );
void AddWidgetText ( PtWidget_t *w , char *s );
char *GetWidgetText ( PtWidget_t *w );
int SetWidgetImage ( PtWidget_t *w , ApDBase_t *wb , const char *im_name );
int SetWidgetArmImage ( PtWidget_t *w , ApDBase_t *wb , const char *im_name );
BOOL SetWidgetPress ( PtWidget_t *w , BOOL pressed );
void SetWidgetUserData ( PtWidget_t *w , void *data , size_t dsize );
void GetWidgetUserData ( PtWidget_t *w , void *data , size_t dsize );
ushort_t GetWidgetState ( PtWidget_t *w );

/* ../translate.c */
void DoneTranslation ( void );
void InitTranslation ( void );
int GetTranslateType ( void );
int SetTranslation ( const char *tr );
int SetTranslateType ( int tr );
char *TranslateString ( char *src );
char *UnTranslateString ( char *src );

/* ../config.c */
int ReadConfig ( void );
int WriteConfig ( void );
GlossarySetting_t *getCurrentSetting ( char *gl_name );
