/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.13X */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <assert.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "pglos.h"
#include "abimport.h"
#include "proto.h"

int DestroyWindow( PtWidget_t *w )
{
	assert( w );
	return PtDestroyWidget( w );
/*	
	PhWindowEvent_t WE;
	int res;
	
	if( !w || !PtWidgetIsClassMember( w, PtWindow ))
		return -1;
		
	memset( &WE, 0, sizeof( WE ));
	WE.event_f = Ph_WM_CLOSE;
	WE.rid = PtWidgetRid( w );
	res = PtForwardWindowEvent( &WE );
	PtProcessEvent();
	return res;
*/
}

/*
void SetWidgetFocus( PtWidget_t *w )
{
	PhEvent_t event;
	
	memset( &event, 0, sizeof( event ));
	PtContainerGiveFocus( w, &event );
}
*/
void EnableWidget( PtWidget_t *w )
{
	PtArg_t arg;

	assert( w );
	PtSetArg( &arg, Pt_ARG_FLAGS, 0, Pt_GHOST );
	PtSetResources( w, 1, &arg );
}

void DisableWidget( PtWidget_t *w )
{
	PtArg_t arg[1];

	assert( w );
	PtSetArg( &arg[0], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST );
	PtSetResources( w, 1, &arg[0] );
}

void SetWindowNormal( PtWidget_t *w )
{	
	PtArg_t arg[2];
	
	assert( w );
	PtSetArg( &arg[0], Pt_ARG_WINDOW_STATE, 0, Ph_WM_STATE_ISFRONT );
	PtSetArg( &arg[1], Pt_ARG_WINDOW_STATE, Ph_WM_STATE_ISNORMAL, 
											Ph_WM_STATE_ISNORMAL );
	PtSetResources( w, 2, arg );
}

void SetWindowTitle( PtWidget_t *w, char *s )
{
	PtArg_t arg;

	if( !w )
		return;
	assert( w );
	PtSetArg( &arg, Pt_ARG_WINDOW_TITLE, s, 0 );
	PtSetResources( w, 1, &arg );
}

void SetWidgetText( PtWidget_t *w, char *s )
{
	PtArg_t arg;

	assert( w );
	PtSetArg( &arg, Pt_ARG_TEXT_STRING, s, 0 );
	PtSetResources( w, 1, &arg );
}

void AddWidgetText( PtWidget_t *w, char *s )
{
	PtArg_t arg;
	char *olds;
	char *news;

	assert( w );
	assert( s );
	PtSetArg( &arg, Pt_ARG_TEXT_STRING, &olds, 0 );
	PtGetResources( w, 1, &arg );

	news = calloc( strlen( s ) + strlen( olds ) + 3, sizeof( char ));
	strcpy( news, olds );
	strcat( news, s );

	PtSetArg( &arg, Pt_ARG_TEXT_STRING, news, 0 );
	PtSetResources( w, 1, &arg );
}


char *GetWidgetText( PtWidget_t *w )
{
	PtArg_t arg;
	char *str;

	assert( w );
	PtSetArg( &arg, Pt_ARG_TEXT_STRING, &str, 0 );
	PtGetResources( w, 1, &arg );

	return str;
}

int SetWidgetImage( PtWidget_t *w, ApDBase_t *wb, const char *im_name )
{
	PhImage_t *image;
	ushort_t arg_type = Pt_ARG_LABEL_DATA;

	assert( wb );
	assert( w );

	if( PtWidgetClass( w ) == PtSlider )
		arg_type = Pt_ARG_SLIDER_IMAGE;

	if(( image = ApGetImageRes( wb, im_name )) != NULL ) 
	{
		PtArg_t arg;
		PtSetArg( &arg, arg_type, image, sizeof(*image));
		PtSetResources( w, 1, &arg );
		return 0;
	}
	return 1;
}

int SetWidgetArmImage( PtWidget_t *w, ApDBase_t *wb, const char *im_name )
{
	PhImage_t *image;
	ushort_t arg_type = Pt_ARG_ARM_DATA;

	assert( wb );
	assert( w );

	if( PtWidgetClass( w ) == PtSlider )
		arg_type = Pt_ARG_SLIDER_IMAGE;

	if(( image = ApGetImageRes( wb, im_name )) != NULL ) 
	{
		PtArg_t arg;
		PtSetArg( &arg, arg_type, image, sizeof(*image));
		PtSetResources( w, 1, &arg );
		return 0;
	}
	return 1;
}

BOOL SetWidgetPress( PtWidget_t *w, BOOL pressed )
{
	PtArg_t arg;

	assert( w );
	PtSetArg( &arg, Pt_ARG_FLAGS, pressed?Pt_SET:0, Pt_SET );
	PtSetResources( w, 1, &arg );

	return pressed;
}

void SetWidgetUserData( PtWidget_t *w, void *data, size_t dsize )
{
	PtArg_t arg;

	assert( w );
	PtSetArg( &arg, Pt_ARG_USER_DATA, data, dsize );
	PtSetResources( w, 1, &arg );

}

void GetWidgetUserData( PtWidget_t *w, void *data, size_t dsize )
{
	PtArg_t arg;

	assert( w );
	PtSetArg( &arg, Pt_ARG_USER_DATA, &data, dsize );
	PtGetResources( w, 1, &arg );

}

ushort_t GetWidgetState( PtWidget_t *w )
{
	PtArg_t arg;
	ushort_t *state;

	assert( w );
	PtSetArg( &arg, Pt_ARG_FLAGS, &state, 0xFFFF );
	PtGetResources( w, 1, &arg );

	return *state;
}
